--[[
	twentytwoo - 2017
	drunkenly made at 2am when i shouldve been asleep

	hail kopparberg dakkjlk;o
]]

-- Require libs
Camera  = require "libs.hump.camera" -- Camera controls
flux    = require "libs.flux"        -- Tweening
shine   = require "libs.shine"       -- Post-processing
Timer   = require "libs.hump.timer"  -- Timed events

mainFont = love.graphics.newFont("pixel.ttf", 64)
love.graphics.setFont(mainFont)

screen = {
    W = love.graphics.getWidth(), -- same as screen.S
    H = love.graphics.getHeight()
}

love.graphics.setDefaultFilter("nearest", "nearest") -- No AA
local crt = shine.crt()
local scanlines = shine.scanlines()
local posterize = shine.posterize()
post_effect =  crt:chain(scanlines):chain(posterize)
posterize.parameters = { num_bands = 8 }

camera = Camera(screen.W/2, screen.H/2, 0.8)

music = love.audio.newSource("dutty.mp3")
music:setVolume(0.8)
music:setLooping(true)
love.mouse.setVisible( false )

-- [[ real spaghetii code fams who upppp ==============]]--

function love.load()
	music:stop()
	music:play()
	math.randomseed(os.time()) -- "real" randomness

	slowmo = {
		max = 380,
		width = 380,
		phi = 0.1
	}
	player = {
		w = 30,
		h = 30,
		x = screen.W/2,
		y = screen.H/2,
		xv = 0,
		yv = 0,
		dir = 1,
		ydir = -1,
		s = 900,
		so = 900,
		dead = false,
		hp = 10,
		opacity=255
	}
	cam = {
		zoom = 1,
		rot = 0
	}

	bullet = {}
	powerup = {}

	positions = {}
	maxPositions = 50
	show_console = false
	canCount = true
	canSlowmo = true
	trail = { opacity = 40 }
	inc = 0
	score = 0
	timer = 10
end


function love.update(dt)
    Timer.update(dt)
	flux.update(dt)

	timer = timer - ((score/5)*dt)
	if timer <= 0 then  -- Executes command when timer reaches 0
		fire()			-- no point changing if it already works
	timer = 50
	end

	if love.keyboard.isDown('w') then show_console = true else show_console = false end
	camera:lockPosition(player.x + (player.w/2), player.y, Camera.smooth.damped(0.5))
	score_counter(dt)

	-- This whole section is just fcked.
	if love.keyboard.isDown(' ') then
	if canSlowmo == true then
		slowmo.width = slowmo.width - (300*dt)
		dt = dt * slowmo.phi
		music:setPitch(0.6) -- one octave lower
	end
	else
		slowmo.width = slowmo.width + (300*dt)
		canSlowmo = true
		music:setPitch(1) -- return
	end
	if slowmo.width > slowmo.max then
		slowmo.width = slowmo.max
		canSlowmo = true
	elseif slowmo.width <= 0 then
		slowmo.width = 0
		canSlowmo = false
		music:setPitch(1) -- return
	end

	player.xv = player.xv * (1 - math.min(dt*8, 1))
	player.x = player.x + player.xv * player.dir * dt
	if love.keyboard.isDown('a') then
		player.dir = -1
		player.xv = player.s
	end
	if love.keyboard.isDown('d') then
		player.dir = 1
		player.xv = player.s
	end
	if player.y < 10 then
		player.ydir = 1
	elseif player.y > screen.H-10 then
		player.ydir = -1
	end
	if player.x < 0 then
		player.x = 0
	elseif player.x > screen.W then
     player.x = screen.W
	end
	player.yv = player.s
	player.y = player.y + player.yv * player.ydir * dt

	if love.keyboard.isDown('q') then
		fire()
	end

	for i, v in ipairs( bullet ) do
        v.x = v.x + v.dx * dt
        v.y = v.y + v.dy * dt
        if v.x < 0 then
        	table.remove(bullet, i)
        end
        if not (v.x < player.x) then -- too lazy for collision detection
	        if (v.x > player.x and v.x < (player.x + player.h )) and (v.y > player.y and v.y < (player.y + player.h))
	         then
	        	table.remove(bullet, i)
	        	player.hp = player.hp - 1
	        	playerHit()
	        end
	    end
    end

    positionActual = { x = player.x, y = player.y}
    table.insert(positions, positionActual)
    if #positions > maxPositions then
       table.remove(positions, 1)
    end

    if player.hp == 0 then playerDead() end
    if player.hp < 0 then player.hp = 0 end

    -- restart
    if love.keyboard.isDown('r') then love.load() end
end

function love.draw()
post_effect:draw(function()
	camera:attach()
	love.graphics.setBackgroundColor( 10+inc, 100/inc, 100-inc, 200 ) -- what the f
	    love.graphics.print(tostring(player.hp), 20, 10, 0, 0.5)
		love.graphics.printf(math.floor(score), screen.W/2+20, 60, 0, "center")
	    love.graphics.rectangle("fill", screen.W/2-slowmo.max/2, 200, slowmo.width, 40 )
		love.graphics.setColor( 255, 255, 255, 20 )
	    love.graphics.rectangle("fill", screen.W/2-slowmo.max/2, 200, slowmo.max, 40 )
		love.graphics.setColor( 255, 0, 255, player.opacity )
	    love.graphics.circle("fill", player.x, player.y, player.w, player.h)
	    for i = 1, #positions do -- player trail
	        love.graphics.setColor(255, 0, 255, ((trail.opacity*0.5)/#positions)*i)
	        love.graphics.circle("fill", positions[i].x, positions[i].y, player.w, player.h)
	    end
	    -- Draw arena
		love.graphics.setColor( 255, 0, 0, 255 )
		love.graphics.rectangle("fill", 0, 0, screen.W ,10)
		love.graphics.rectangle("fill", 0, screen.H-10, screen.W ,10)
		love.graphics.rectangle("fill", 0, 0, 10 ,screen.H)
		love.graphics.rectangle("fill", screen.W-10, 0, 10, screen.H)
		love.graphics.setColor( 255, 255, 0, 255 )

	    for i, v in ipairs( bullet ) do
			love.graphics.rectangle("fill", v.x, v.y, 20, 20)
	    end

		love.graphics.setColor( 255, 255, 255, 255 )
		if player.hp <= 0 then
	    	love.graphics.print("Game over!", player.x-290, player.y)
	    	love.graphics.print("Press R to restart", player.x-90, player.y+120, 0, 0.2)
	    end
	    camera:detach()
	end) -- Of shader
	if show_console == true then
    love.graphics.print("FPS: "..tostring(love.timer.getFPS( )), screen.W-100, 20, 0, 0.2)
    love.graphics.print( -- Crappy console
    	"space_pressed: " .. tostring(space_pressed) .. "\n" ..
    	"can_slowmo: "    .. tostring(canSlowmo)    .. "\n" ..
    	"xv: "      	  .. tostring(rnd(player.xv))    .. "\n" ..
    	"y: "             .. tostring(player.y)    .. "\n" ..
    	"yd: "            .. tostring(player.ydir)    .. "\n" ..
    	"timer: "            .. tostring(timer)    .. "\n" ..
    	"blox: "          .. tostring(tablelength(bullet))    .. "\n"
    	,10,10,0,0.15)
	end
end

function rnd(v, p)
if p == nil then p = 3 end
local scale = math.pow(10, p or 0);
local res = math.floor(math.abs(v) * scale + 0.5) / scale;
    if v < 0 then res = -res; end;
    return res;
end;

function score_counter(dt)
	if canCount == true then
		score = score + (15*dt)
	else score = score
	end
end

function shakeCam()
    local orig_x, orig_y = camera:position()
    Timer.during(0.3, function()
        camera:lookAt(orig_x + math.random(-20,20), orig_y + math.random(-20,20) )
    end, function()
    end)
end

function fire()
    table.insert( bullet, { x = screen.W-10 , y = 10+math.random(screen.H)-10, dx = -player.s*0.8, dy = 0 } )
end

function tablelength(T)
  local count = 0
  for _,v in pairs(T) do count = count + 1 end
  return count
end

function playerDead()
	flux.to(player, 1, {opacity = 0, s = 0} )
	flux.to(trail, 1, {opacity = 0} )
	canCount = false
	canSlowmo = false
end

function playerHit()
	shakeCam()
	playSound("hit")
end

function playSound(sound)
    local hit_1 = love.audio.newSource("hit_1.wav", "static")
    local hit_2 = love.audio.newSource("hit_2.wav", "static")
    local num = math.random(2)
    if sound == "hit" then
        if num == 1 then
            hit_1:play()
        elseif num == 2 then
            hit_2:play()
        end
    end
end